import Main from "./main";
import Router from "./Router";

/* Navigation */
const routes = [
  { path: "/", page: "home" },
  { path: "/play", page: "play" },
  { path: "/map", page: "map" },
];
let router = new Router(routes);

const links = document.querySelectorAll("a");
for (let i = 0; i < links.length; i++) {
  links[i].addEventListener("click", (e) => {
    e.preventDefault();

    let target = e.currentTarget as HTMLElement;
    if (target) {
      let href = target.getAttribute("href");
      if (href) {
        router.ChangePages(href);
      }
    }
  });
}

const inputName = document.querySelector(".name");
const slides = document.querySelectorAll(".slide");

let playerCharacter: string | null = "goku";
let playerName = "";

if (inputName)
  inputName.addEventListener("input", (e) => {
    e.preventDefault();
    const target = e.currentTarget as HTMLInputElement;
    playerName = target.value;
  });

for (let i = 0; i < slides.length; i++) {
  slides[i].addEventListener("click", (e) => {
    let player = e.currentTarget as HTMLElement;
    playerCharacter = player.getAttribute("name");
    console.log(playerCharacter);
  });
}

const startButton = document.querySelector(".start-button");

if (startButton)
  startButton.addEventListener("click", (e) => {
    e.preventDefault();
    if (playerName.length > 0) {
      router.ChangePages("/map");
      if (playerCharacter) Main(playerName, playerCharacter);
    }
  });
